home PYTHONJAVA
 

Python3 error and exceptions

As a Python beginner, when you first learn Python programming, you will often see some error messages. We didn't mention them in the previous section. We will introduce them in this chapter.

Python has two types of errors that are easy to identify: syntax errors and exceptions.

Syntax error

Python's syntax errors, or parsing errors, are common to beginners, as in the following examples

>>>while True print< /span>('Hello world') File "<stdin>", line 1, in ? while True print('Hello world')< /span> ^ SyntaxError: invalid syntax

In this example, the function print() is checked for errors, which is missing a colon (:) in front of it.

The parser pointed out the line that was in error and marked a small arrow at the location of the error found first.

Exception

Even if the syntax of the Python program is correct, an error may occur while running it. Errors detected during runtime are called exceptions.

Most exceptions are not handled by the program and are presented here as error messages:

>>>10 * (1 /0) Traceback (most recent call last ): File "<stdin>", line 1, in ? ZeroDivisionError: division by zero >>> 4 + Spam*3 Traceback (most recent call last ): File "<stdin>", line 1, in ? NameError: name 'spam' is not defined >>> '2 ' + 2 Traceback (most recent call last ): File "<stdin>", line 1, in ? TypeError: Can't convert 'int' object to str implicitly

Exceptions appear in different types, and these types are printed as part of the information: The types in the examples are ZeroDivisionError, NameError, and TypeError.

The front part of the error message shows the context in which the exception occurred and displays the specific information in the form of a call stack.

Exception handling

In the following example, let the user enter a valid integer, but allow the user to interrupt the program (using Control-C or the method provided by the operating system). User interrupted messages will raise a KeyboardInterrupt exception.

>>>while True: try: x = int(input("Please enter a number: ")) break except ValueError: print("Oops! That was no valid number. Try again ")
The

try statement works as follows;

  • First, execute the try clause (the statement between the keyword try and the keyword except)
  • If no exception occurs, the except clause is ignored and the try clause ends after execution.
  • If an exception occurs during the execution of the try clause, the rest of the try clause will be ignored. If the type of the exception matches the name after except, the corresponding except clause will be executed. Finally execute the code after the try statement.
  • If an exception does not match any except, then the exception will be passed to the upper try.

A try statement may contain multiple except clauses to handle different specific exceptions. At most only one branch will be executed.

The

handler will only handle exceptions in the corresponding try clause, not exceptions in other try handlers.

An exception clause can handle multiple exceptions at the same time. These exceptions will be placed in parentheses as a tuple, for example:

except ( RuntimeError, TypeError, NameError): pass

The last except clause can ignore the name of the exception and it will be used as a wildcard. You can use this method to print an error message and then throw the exception again.

import sys try: f= open('myfile.txt') s= f.readline() i= int(s.strip()) except OSError as err: print(" OS blunder: {0}".format(err)) except ValueError: print(" Could not change over information to an integer.") except: print(" Unexpected error:", sys.exc_info()[0]) raise
The

try except statement also has an optional else clause. If you use this clause, you must put it after all the except clauses. This clause will be executed when there is no exception in the try clause. E.g:

for arg in sys.argv[1:]: try: f = open(arg, 'r') except IOError: print('cannot open', arg) else: print(arg, 'has', len(f.readlines()), 'lines') f.close()

It's smarter to utilize the else provision than to put every one of the announcements in the attempt statement, so you can dodge unforeseen special cases that are not gotten by with the exception of.

Exception taking care of does not just arrangement with special cases that happen straightforwardly in the attempt proviso, yet additionally handles exemptions tossed in capacities brought in provisos (or even in a roundabout way called capacities). For example:

>>>def this_fails() : x= 1/0 >>> try: this_fails() except ZeroDivisionError as err: print('Handling run-time error:', err) Handling run-time error: int division or modulo by zero

Throw an exception

Python uses the raise statement to throw a specified exception. For example:

>>>raise NameError('HiThere') Traceback (most recent call last): File "<stdin>", line 1, in ? NameError: HiThere

raise The only parameter that specifies the exception to be thrown. It must be an exception instance or an exception class (that is, a subclass of Exception ).

If you just want to know if this throws an exception and doesn't want to handle it, then a simple raise statement can throw it again.

>>>try: raise NameError('HiThere') except NameError: print('An exception flew by!') raise An exception flew by! Traceback (most recent call last): File "<stdin>", line 2, in ? NameError: HiThere

User-defined exception

You can have your own exception by creating a new exception class. Exception classes inherit from the Exception class and can be inherited directly or indirectly, for example:

>>>class MyError(Exception): def __init__(self, value): self.value = value def __str__(self): return repr(self.value) >>> try: raise MyError(2*2) except MyError as e: print('My exception occurred, value:', e.value) My exception occurred, value: 4 >>> raise MyError('oops!') Traceback (most recent call last): File "<stdin>", line 1, in ? __main__.MyError: 'oops!'

The names of most exceptions end with "Error", just like the standard exception name.


Define cleanup behavior

The

try statement has an optional clause that defines the cleanup behavior that will be performed under any circumstances. For example:

>>>try: ... raise KeyboardInterrupt ... finally: ... print('Goodbye, world!') ... Goodbye, world! Traceback (most recent call last ): File "<stdin>", line 2, in <module< /span>> KeyboardInterrupt

The above model will execute paying little heed to whether there is a special case in the attempt condition.

If an exemption is tossed in the attempt statement (or in the aside from and else conditions) with no special case capturing it, at that point the exemption will be tossed again after the at long last proviso is executed. .

The following is an increasingly confounded precedent (with the aside from lastly provisos in a similar attempt statement):

>>>def divide(x, y): try: result = x / y except ZeroDivisionError: print("division by zero!") else: print("result is", result) finally: print("executing finally clause") >>> divide(2, 1) result is 2.0 executing finally clause >>> divide(2, 0) division by zero! executing finally clause >>> divide("2", "1") executing finally clause Traceback (most recent call last): File "<stdin>", line 1, in ? File "<stdin>", line 3, in divide TypeError: unsupported operand type(s) for /: 'str' and 'str'

Predefined cleanup behavior

Some objects characterize standard cleanup conduct, paying little respect to whether the framework effectively utilized it, and once it isn't required, at that point this standard cleanup conduct will be performed.

This model shows endeavoring to open a document and afterward print the substance to the screen:

for line in open("myfile.txt"): print(line, end="")

The issue with this code is that when the execution is finished, the document will stay open and not shut.

The catchphrase with proclamation guarantees that items, for example, documents will accurately execute their cleanup strategies after they are used:

with open ("myfile.txt") as f: for line in f: print(line, end="")

After the above code is executed, regardless of whether there is an issue amid preparing, the document f will dependably be shut.






welookups is optimized for learning.© welookups. 2018 - 2019 All Right Reserved and you agree to have read and accepted our term and condition.